
window.addEventListener('load', function() {
	var old_func = window.BrowserToolboxCustomizeDone;
	window.BrowserToolboxCustomizeDone = function(aToolboxChanged) {
		toggleSearch.addEvents();
		old_func(aToolboxChanged);
	};
	
	toggleSearch.addEvents();
},false);

var toggleSearch = {
	toggled: false,
	toggle: function() {
		this.flexer = document.getElementById('search-container');
		var searchbar = document.getElementById('searchbar');
		var textbox = document.getAnonymousElementByAttribute(searchbar, "anonid", "searchbar-textbox");
		var button = document.getElementById('toggle-search-button');
		
		var siblings = this.flexer.parentNode.childNodes;
	
		this.maxFlex = 1;
		for (var i=0; i< siblings.length; i++) {
			if (siblings[i] == this.flexer)
				continue;
			var flex = parseInt(siblings[i].flex);
			if (!isNaN(flex))
				this.maxFlex = Math.max(this.maxFlex,flex);
		}
		this.maxFlex *= 2;
		
		if (this.toggleTimer)
				
			clearTimeout(this.toggleTimer);
		
			
		
		this.toggleProgress = parseFloat(this.flexer.flex) / this.maxFlex;
		
		if (toggleSearch.toggled) {
			if (textbox.focused) {
				window.setTimeout(function() {
					document.commandDispatcher.advanceFocus();
				},10);
				return;
			}
			
			toggleSearch.toggled = false;
			if (button)
				button.checked = false;
			
			
			this.toggleProgress -= 0.01;
			this.toggleDirection = -1;
			this.keepToggling();

		} else {
			if (!textbox.focused) {
				window.setTimeout(function() {
					textbox.focus();
					textbox.select();
				},10);
				return;
			}
			
			toggleSearch.toggled = true;
			if (button)
				button.checked = true;
			
			
			this.toggleProgress += 0.01;
			this.toggleDirection = 1;
			
			this.keepToggling();
		}
	},
	keepToggling: function() {
		this.toggleProgress += this.toggleDirection * 0.1;	
		if (this.toggleProgress > 1) {
			this.flexer.flex = Math.round(this.maxFlex);
		} else if (this.toggleProgress < 0) {
			this.flexer.flex = 0;
		} else {
			var fx = (-Math.cos(this.toggleProgress*Math.PI)/2) + 0.5;
			
			this.flexer.flex = Math.round(fx*this.maxFlex);
		
			var self = this;
			this.toggleTimer = setTimeout(function(){
				
				self.keepToggling();
			
			}, 25);
		}
	},
	onSearchFocus: function() {
		if (!toggleSearch.toggled)
			toggleSearch.toggle();
	},
	onSearchBlur: function() {
		if (toggleSearch.toggled)
			toggleSearch.toggle();
	},
	addEvents: function() {
		var searchbar = document.getElementById('searchbar');
		var textbox = document.getAnonymousElementByAttribute(searchbar, "anonid", "searchbar-textbox");
		
		textbox.removeEventListener('focus', toggleSearch.onSearchFocus, true);
		textbox.removeEventListener('blur', toggleSearch.onSearchBlur, true);
		
		textbox.addEventListener('focus', toggleSearch.onSearchFocus, true);
		textbox.addEventListener('blur', toggleSearch.onSearchBlur, true);
	
		if (!searchbar._origHandleSearchCommand) {
			searchbar._origHandleSearchCommand = searchbar.handleSearchCommand;
		}
		
		searchbar.handleSearchCommand = function() {  
			if (!toggleSearch.toggled)
				this._textbox.focus();
			else
				this._origHandleSearchCommand.apply(this,arguments);
		};
	}
};